//  Copyright 2008 Actel Corporation.  All rights reserved.
// ANY USE OR REDISTRIBUTION IN PART OR IN WHOLE MUST BE HANDLED IN
// ACCORDANCE WITH THE ACTEL LICENSE AGREEMENT AND MUST BE APPROVED
//  Revision Information:
// Jun09    Revision 4.1
// SVN Revision Information:
// SVN $Revision: 8508 $
`timescale 1ns/1ns
module
CoreUARTapb
(
PCLK
,
PRESETN
,
PADDR
,
PSEL
,
PENABLE
,
PWRITE
,
PWDATA
,
PRDATA
,
TXRDY
,
RXRDY
,
PARITY_ERR
,
OVERFLOW
,
RX
,
TX
)
;
parameter
FAMILY
=
15
;
parameter
TX_FIFO
=
0
;
parameter
RX_FIFO
=
0
;
parameter
BAUD_VALUE
=
0
;
parameter
FIXEDMODE
=
0
;
parameter
PRG_BIT8
=
0
;
parameter
PRG_PARITY
=
0
;
parameter
RX_LEGACY_MODE
=
0
;
input
PCLK
;
input
PRESETN
;
input
[
4
:
0
]
PADDR
;
input
PSEL
;
input
PENABLE
;
input
PWRITE
;
input
[
7
:
0
]
PWDATA
;
output
[
7
:
0
]
PRDATA
;
output
TXRDY
;
output
RXRDY
;
input
RX
;
output
TX
;
output
PARITY_ERR
;
output
OVERFLOW
;
`define CUARTIIOI  \
3 \
'b \
000
`define CUARTlIOI  \
3 \
'b \
001
`define CUARTOlOI  \
3 \
'b \
010
`define CUARTIlOI  \
3 \
'b \
011
`define CUARTllOI  \
3 \
'b \
100
wire
PCLK
;
wire
PRESETN
;
wire
[
4
:
0
]
PADDR
;
wire
PSEL
;
wire
PENABLE
;
wire
PWRITE
;
wire
[
7
:
0
]
PWDATA
;
wire
[
7
:
0
]
PRDATA
;
wire
TXRDY
;
wire
RXRDY
;
wire
RX
;
wire
TX
;
reg
[
7
:
0
]
CUARTO0OI
;
reg
[
7
:
0
]
CUARTI0OI
;
reg
[
7
:
0
]
CUARTl0OI
;
reg
[
7
:
0
]
CUARTO1OI
;
wire
CUARTI1OI
;
wire
[
7
:
0
]
CUARTl1OI
;
wire
[
7
:
0
]
CUARTOOII
;
wire
[
12
:
0
]
CUARTIl
;
wire
CUARTIO1
;
wire
CUARTlO1
;
wire
CUARTOI1
;
wire
CUARTIOII
;
wire
CUARTlOII
;
wire
CUARTOIII
;
wire
OVERFLOW
;
wire
PARITY_ERR
;
wire
[
1
:
0
]
CUARTIIII
;
wire
CUARTlIII
;
wire
CUARTOlII
;
wire
CUARTIlII
;
assign
CUARTIOII
=
!
(
PENABLE
&&
PWRITE
&&
(
PADDR
[
4
:
2
]
==
`CUARTIIOI
)
)
;
assign
CUARTlOII
=
!
(
PENABLE
&&
!
PWRITE
&&
(
PADDR
[
4
:
2
]
==
`CUARTlIOI
)
)
;
assign
CUARTOIII
=
!
PSEL
;
assign
CUARTl1OI
=
PWDATA
;
assign
CUARTI1OI
=
(
PSEL
&
!
PWRITE
&
!
PENABLE
)
;
always
@
(
PADDR
or
CUARTI1OI
or
CUARTO1OI
or
CUARTOOII
or
CUARTO0OI
or
CUARTI0OI
or
OVERFLOW
or
PARITY_ERR
or
RXRDY
or
TXRDY
or
CUARTIlII
)
begin
:
CUARTllII
if
(
CUARTI1OI
)
case
(
PADDR
[
4
:
2
]
)
`CUARTIIOI
:
CUARTl0OI
=
8
'b
0
;
`CUARTlIOI
:
CUARTl0OI
=
CUARTOOII
;
`CUARTOlOI
:
CUARTl0OI
=
CUARTO0OI
;
`CUARTIlOI
:
CUARTl0OI
=
CUARTI0OI
;
`CUARTllOI
:
CUARTl0OI
=
{
3
'b
0
,
CUARTIlII
,
OVERFLOW
,
PARITY_ERR
,
RXRDY
,
TXRDY
}
;
default
:
CUARTl0OI
=
CUARTO1OI
;
endcase
else
CUARTl0OI
=
CUARTO1OI
;
end
assign
CUARTIIII
=
PRG_PARITY
;
assign
CUARTlIII
=
(
CUARTIIII
==
2
'd
1
||
CUARTIIII
==
2
'd
2
)
?
1
'b
1
:
1
'b
0
;
assign
CUARTOlII
=
(
CUARTIIII
==
2
'd
1
)
?
1
'b
1
:
1
'b
0
;
always
@
(
posedge
PCLK
or
negedge
PRESETN
)
begin
:
CUARTO0II
if
(
!
PRESETN
)
CUARTO1OI
<=
8
'b
0
;
else
CUARTO1OI
<=
CUARTl0OI
;
end
assign
PRDATA
=
CUARTO1OI
;
always
@
(
posedge
PCLK
or
negedge
PRESETN
)
begin
:
CUARTI0II
if
(
!
PRESETN
)
CUARTO0OI
<=
8
'b
0
;
else
if
(
PSEL
&&
PENABLE
&&
PWRITE
&&
(
PADDR
[
4
:
2
]
==
`CUARTOlOI
)
)
CUARTO0OI
<=
PWDATA
;
else
CUARTO0OI
<=
CUARTO0OI
;
end
assign
CUARTIl
=
FIXEDMODE
?
BAUD_VALUE
:
{
CUARTI0OI
[
7
:
3
]
,
CUARTO0OI
}
;
always
@
(
posedge
PCLK
or
negedge
PRESETN
)
begin
:
CUARTl0II
if
(
!
PRESETN
)
CUARTI0OI
<=
8
'b
0
;
else
if
(
PSEL
&&
PENABLE
&&
PWRITE
&&
(
PADDR
[
4
:
2
]
==
`CUARTIlOI
)
)
CUARTI0OI
<=
PWDATA
[
7
:
0
]
;
else
CUARTI0OI
<=
CUARTI0OI
;
end
assign
CUARTIO1
=
FIXEDMODE
?
PRG_BIT8
:
CUARTI0OI
[
0
]
;
assign
CUARTlO1
=
FIXEDMODE
?
CUARTlIII
:
CUARTI0OI
[
1
]
;
assign
CUARTOI1
=
FIXEDMODE
?
CUARTOlII
:
CUARTI0OI
[
2
]
;
COREUART
#
(
.TX_FIFO
(
TX_FIFO
)
,
.RX_FIFO
(
RX_FIFO
)
,
.RX_LEGACY_MODE
(
RX_LEGACY_MODE
)
)
CUARTO1II
(
.RESET_N
(
PRESETN
)
,
.CLK
(
PCLK
)
,
.WEN
(
CUARTIOII
)
,
.OEN
(
CUARTlOII
)
,
.CSN
(
CUARTOIII
)
,
.DATA_IN
(
CUARTl1OI
)
,
.RX
(
RX
)
,
.BAUD_VAL
(
CUARTIl
)
,
.BIT8
(
CUARTIO1
)
,
.PARITY_EN
(
CUARTlO1
)
,
.ODD_N_EVEN
(
CUARTOI1
)
,
.FRAMING_ERR
(
CUARTIlII
)
,
.PARITY_ERR
(
PARITY_ERR
)
,
.OVERFLOW
(
OVERFLOW
)
,
.TXRDY
(
TXRDY
)
,
.RXRDY
(
RXRDY
)
,
.DATA_OUT
(
CUARTOOII
)
,
.TX
(
TX
)
)
;
endmodule
